## massivethreads 1.00

=== examples/task_group/Makefile ===
### set MASSIVE_INST_DIR so it points to where
### you installed MassiveThreads (i.e., what you gave
### to --prefix)
# MASSIVE_INST_DIR?=../../src/

CXXFLAGS:=-std=c++0x -g -pthread -ggdb -Wall -I../../src/ -I../../include
CXX:=g++
LIBS=-Wl,-R../../src/.libs -L../../src/.libs -lmyth -ldl

fib : fib.o
	$(CXX) $(CXXFLAGS) -o $@ $< $(LIBS)

clean :
	rm -f fib fib.o

=== docs/texinfo/examples/Makefile ===
mtbb_cc    := $(wildcard *_mtbb.cc)
mtbb_dr_cc := $(wildcard *_mtbb_dr.cc)
omp_cc     := $(wildcard *_omp.cc)
omp_dr_cc  := $(wildcard *_omp_dr.cc)
cilkplus_raw_c := $(wildcard *_cilkplus_raw.c)
cilkplus_raw_dr_c := $(wildcard *_cilkplus_raw_dr.c)
cilkplus_c := $(wildcard *_cilkplus.c)
cilkplus_dr_c := $(wildcard *_cilkplus_dr.c)
cilk_cilk := $(wildcard *_cilk.cilk)
cilk_dr_cilk := $(wildcard *_cilk_dr.cilk)

mtbb_exe    := $(patsubst %.cc,%,$(mtbb_cc))
mtbb_dr_exe := $(patsubst %.cc,%,$(mtbb_dr_cc))
omp_exe     := $(patsubst %.cc,%,$(omp_cc))
omp_dr_exe  := $(patsubst %.cc,%,$(omp_dr_cc))
cilkplus_raw_exe     := $(patsubst %.c,%,$(cilkplus_raw_c))
cilkplus_raw_dr_exe  := $(patsubst %.c,%,$(cilkplus_raw_dr_c))
cilkplus_exe     := $(patsubst %.c,%,$(cilkplus_c))
cilkplus_dr_exe  := $(patsubst %.c,%,$(cilkplus_dr_c))
cilk_exe     := $(patsubst %.cilk,%,$(cilk_cilk))
cilk_dr_exe  := $(patsubst %.cilk,%,$(cilk_dr_cilk))

prefix:=$(HOME)/parallel2/sys/inst/g

all : $(mtbb_exe) $(mtbb_dr_exe) $(omp_exe) $(omp_dr_exe) $(cilkplus_raw_exe) $(cilkplus_raw_dr_exe) $(cilkplus_exe) $(cilkplus_dr_exe) $(cilk_exe) $(cilk_dr_exe)

#CC:=$(prefix)/gcc/bin/gcc
#CILKC:=$(prefix)/cilk/bin/cilkc
CC:=gcc
CXX:=g++
CILKC:=cilkc
CFLAGS := -I$(prefix)/include -O0 -g
CXXFLAGS := -std=c++0x -I$(prefix)/include -O0 -g
LDFLAGS := -L$(prefix)/lib -Wl,-R$(prefix)/lib 

$(mtbb_exe) : % : %.cc
	$(CXX) -o $@ $(CXXFLAGS) $(LDFLAGS) $^ -lmyth-native

$(mtbb_dr_exe) : % : %.cc
#	$(CXX) -o $@ $(CXXFLAGS) -DTO_SERIAL -DDAG_RECORDER=2 $(LDFLAGS) $^ -ldr -lpthread
	$(CXX) -o $@ $(CXXFLAGS) -DDAG_RECORDER=2 $(LDFLAGS) $^ -lmyth-native -ldr -lpthread

$(omp_exe) : % : %.cc
	$(CXX) -o $@ -fopenmp $(CXXFLAGS) $(LDFLAGS) $^

$(omp_dr_exe) : % : %.cc
	$(CXX) -o $@ -fopenmp $(CXXFLAGS) -DDAG_RECORDER=2 $(LDFLAGS) $^ -ldr

$(cilkplus_raw_exe) : % : %.c
	$(CC) -o $@ -fcilkplus $(CFLAGS) $(LDFLAGS) $^ -lcilkrts

$(cilkplus_raw_dr_exe) : % : %.c
	$(CC) -o $@ -fcilkplus $(CFLAGS) -DDAG_RECORDER=2 $(LDFLAGS) $^ -ldr -lcilkrts

$(cilkplus_exe) : % : %.c
	$(CC) -o $@ -fcilkplus $(CFLAGS) $(LDFLAGS) $^

$(cilkplus_dr_exe) : % : %.c
	$(CC) -o $@ -fcilkplus $(CFLAGS) -DDAG_RECORDER=2 $(LDFLAGS) $^ -ldr

$(cilk_exe) : % : %.cilk
	$(CILKC) -o $@ $(CFLAGS) $(LDFLAGS) $^

$(cilk_dr_exe) : % : %.cilk
	$(CILKC) -o $@ $(CFLAGS) -DDAG_RECORDER=2 $(LDFLAGS) $^ -ldr

=== examples/bench/fiber/Makefile ===
CC=gcc
CFLAGS=-Wall -O3
TARGETS=jmp ctx mix

all: $(TARGETS)

jmp: main.c jmp.c fiber.h
	$(CC) -o $@ jmp.c main.c $(CFLAGS)

ctx: main.c ctx.c fiber.h
	$(CC) -o $@ ctx.c main.c $(CFLAGS)

mix: main.c mix.c fiber.h
	$(CC) -o $@ mix.c main.c $(CFLAGS)

.PHONY: clean
clean:
	rm -f $(TARGETS)

=== debian/changelog ===
massivethreads (1.00-1) unstable; urgency=medium

  * Initial release. (Closes: #878278)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Thu, 03 May 2018 07:23:15 +0900

=== debian/control ===
Source: massivethreads
Maintainer: Nobuhiro Iwamatsu <iwamatsu@debian.org>
Priority: optional
Section: devel
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.5.1
Homepage: https://github.com/massivethreads/massivethreads
Vcs-Browser: https://salsa.debian.org/debian/massivethreads
Vcs-Git: https://salsa.debian.org/debian/massivethreads.git

Package: libmassivethreads0
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Lightweight Thread Library for High Productivity Languages - libs
 This provides a multithreaded processing library to achieve
 dynamic load balancing within compute nodes.
 .
 This package includes the shared library.

Package: libmassivethreads-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libmassivethreads0 (= ${binary:Version})
Description: Lightweight Thread Library for High Productivity Languages - devel
 This provides a multithreaded processing library to achieve
 dynamic load balancing within compute nodes.
 .
 This package contains files that are needed to build applications.

# Package: massivethreads
# Architecture: any
# Pre-Depends: ${misc:Pre-Depends}
# Depends: ${shlibs:Depends}, ${misc:Depends}, libmassivethreads0 (= ${binary:Version})
# Multi-Arch: foreign
# Description: Lightweight Thread Library for High Productivity Languages - tools
#  This provides a multithreaded processing library to achieve
#  dynamic load balancing within compute nodes.
#  .
#  This package contains files that is tool using libmassivethreads0.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --exclude=.la

override_dh_auto_install:
	dh_auto_install
	rm $(CURDIR)/debian/tmp/usr/bin/*

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/massivethreads-$1.tar.gz/,dversionmangle=s/\+dfsg// \
  https://github.com/massivethreads/massivethreads/tags .*/v?(\d\S*)\.tar\.gz

## massivethreads 1.02

=== docs/texinfo/Makefile ===
#
# Makefile for generating documents
# 
# massivethreads.pdf
# massivethreads.info
# massivethreads.html
#
# distribution contains them so you normally have to run this.
#
# to generate them, you need
# (1) makeinfo (install texinfo package).
# (2) texinfo.tex in this directory (install texinfo package and then
#     copy texinfo.tex here).
# (3) dvipdfm (for gxpman.pdf)
#

manual = massivethreads

#
# svg files
# 
svgs     := $(wildcard svg/*.svg)
svg_epss := $(patsubst %.svg,%.eps,$(svgs))
svg_pdfs := $(patsubst %.svg,%.pdf,$(svgs))
svg_bbs  := $(patsubst %.svg,%.bb,$(svgs))
svg_pngs := $(patsubst %.svg,%.png,$(svgs))
#
# gnuplot files
#
gpls     := $(wildcard gpl/*.gpl)
gpl_pngs := $(patsubst %.gpl,%.png,$(gpls))
gpl_epss := $(patsubst %.gpl,%.eps,$(gpls))
# 
# images
# 
pngs         := $(filter-out %_resized.png,$(wildcard img/*.png))
resized_pngs := $(patsubst %.png,%_resized.png,$(pngs))
resized_epss := $(patsubst %.png,%_resized.eps,$(pngs))

images := $(svg_pngs) $(gpl_pngs) $(resized_epss) 

all : $(manual).pdf $(manual).info $(manual).html 

$(manual).tex : $(manual)_src.tex
	emacs -q -batch --load=make_texinfo.el

$(manual).info : $(manual).tex
	makeinfo --fill-column=70 $(manual).tex

$(manual).dvi : $(manual).tex $(images)
	tex $(manual).tex

$(manual).pdf : $(manual).dvi
	dvipdfm $(manual).dvi

$(manual).html : $(manual).tex $(images)
	makeinfo --no-split --force --html --css-include=massivethreads.css --fill-column=70 --output $@ $< 

#
# svg files
# 

$(svg_epss) : %.eps : %.svg
	inkscape --export-eps=$@ $<

$(svg_pdfs) : %.pdf : %.eps
	convert $< $@

$(svg_bbs) : %.bb : %.pdf
	ebb $< 

$(svg_pngs) : %.png : %.eps
	convert $< -resize 600x $@

#
# gnuplot files
#

$(gpl_epss) : %.eps : %.gpl
	echo -n | gnuplot -e 'set terminal postscript eps enhanced color' -e 'set output "$@"' $< 

$(gpl_pngs) : %.png : %.eps
	convert $< -resize 600x $@

# 
# images
# 

$(resized_pngs) : %_resized.png : %.png
	convert $< -resize 600x400 $@

$(resized_epss) : %_resized.eps : %_resized.png
	convert $< $@

clean :
	rm -f $(manual).aux $(manual).log $(manual).cp $(manual).info-1 $(manual).md 
	rm -f $(manual).toc $(manual).info-2 $(manual).pg $(manual).tp $(manual).fn $(manual).ky $(manual).vr $(manual).dvi

=== examples/bench/Makefile ===
CC=gcc

# add C flags and C++ flags
CC_CXX_FLAGS=-O3 
CFLAGS=$(CC_CXX_FLAGS)
CXXFLAGS=$(CC_CXX_FLAGS)
LDFLAGS=@../../src/myth-ld.opts -Wl,-R../../src/.libs -L../../src/.libs -lmyth-ld

.PHONY: debug clean

all: mm tree hybrid_tree tmfunc

mm: mm.c
	$(CC) -o $@ $< $(CC_CXX_FLAGS) $(LDFLAGS)

tree: tree.c
	$(CC) -o $@ $< $(CC_CXX_FLAGS) $(LDFLAGS) -lm

hybrid_tree: hybrid_tree.c
	$(CC) -o $@ $< $(CC_CXX_FLAGS) $(LDFLAGS) -lm

tmfunc: tmfunc.c
	$(CC) -o $@ $< $(CC_CXX_FLAGS) $(LDFLAGS)

debug: mm_debug tree_debug hybrid_tree_debug

mm_debug: mm.c
	$(CC) -o $@ $< -pthread -ggdb $(CC_CXX_FLAGS)

tree_debug: tree.c
	$(CC) -o $@ $< -pthread -ggdb -lm $(CC_CXX_FLAGS)

hybrid_tree_debug: hybrid_tree.c
	$(CC) -o $@ $< -pthread -ggdb -lm $(CC_CXX_FLAGS)

clean: 
	rm -f mm tree hybrid_tree tmfunc mm_debug tree_debug hybrid_tree_debug

=== examples/fib/Makefile ===
CC=gcc
CFLAGS=-O3
LDFLAGS=@../../src/myth-ld.opts -Wl,-R../../src/.libs -L../../src/.libs -lmyth-ld

.PHONY: debug clean

all: fib fib2

fib: fib.c
	$(CC) -o $@ $< $(CFLAGS) $(LDFLAGS)

fib2: fib2.c
	$(CC) -o $@ $< $(CFLAGS) $(LDFLAGS)

debug:
	$(CC) -o fib fib.c -pthread -ggdb $(CFLAGS)
	$(CC) -o fib2 fib2.c -pthread -ggdb $(CFLAGS)

clean: 
	rm -f fib fib2

=== examples/nbody/Makefile ===
APP = nbody

# add C flags and C++ flags
CC_CXX_FLAGS = -O3 
CFLAGS = $(CC_CXX_FLAGS)
CXXFLAGS = $(CC_CXX_FLAGS)

SRCS = $(APP).cc def.cc force.cc genpar.cc gentree.cc def.h
.PHONY: debug clean

$(APP): $(SRCS)
	$(CXX) -o $(APP) $(SRCS) $(CC_CXX_FLAGS) -L../../.libs -lmyth-compat

debug:
	$(CXX) -o $(APP) $(SRCS) -pthread -ggdb $(CC_CXX_FLAGS)

clean: 
	rm -f $(APP)

=== examples/treecode/Makefile ===
CC=gcc
PROG=treecode

# add C flags and C++ flags
CC_CXX_FLAGS = -O3 -lm
CFLAGS = $(CC_CXX_FLAGS)
CXXFLAGS = $(CC_CXX_FLAGS)
LDFLAGS=@../../src/myth-ld.opts -Wl,-R../../src/.libs -L../../src/.libs -lmyth-ld

SRCS = $(PROG).cc vector.cc mol.cc tree.cc opts.cc utils.cc
.PHONY: cver debug clean

all: cver

cver: treecode.c
	$(CC) -o $(PROG) $< $(CFLAGS) $(LDFLAGS)

debug: treecode.c
	$(CC) -o $(PROG) $? -pthread -ggdb -lm

clean: 
	rm -f $(PROG)

=== src/chapel-if/1.12/runtime/src/tasks/massivethreads/Makefile ===
RUNTIME_ROOT = ../../..
RUNTIME_SUBDIR = src/tasks/$(CHPL_MAKE_TASKS)

ifndef CHPL_MAKE_HOME
export CHPL_MAKE_HOME=$(shell pwd)/$(RUNTIME_ROOT)/..
endif

include $(RUNTIME_ROOT)/make/Makefile.runtime.head

TASKS_OBJDIR = $(RUNTIME_OBJDIR)
include Makefile.share

TARGETS = $(TASKS_OBJS)

include $(RUNTIME_ROOT)/make/Makefile.runtime.subdirrules

FORCE:

#
# standard footer
#
include $(RUNTIME_ROOT)/make/Makefile.runtime.foot

=== src/chapel-if/1.4.0/runtime/src/tasks/myth/Makefile ===
#
# Copyright (c) 2004-2011, Cray Inc.  (See LICENSE file for more details)
#

RUNTIME_ROOT = ../../..
RUNTIME_SUBDIR = src/tasks/$(CHPL_MAKE_TASKS)

#
# standard header
#
include $(RUNTIME_ROOT)/make/Makefile.runtime.head

TASKS_OBJDIR = $(RUNTIME_OBJDIR)
include Makefile.share

TARGETS = $(TASKS_OBJS)

include $(RUNTIME_ROOT)/make/Makefile.runtime.subdirrules

FORCE:

#
# standard footer
#
include $(RUNTIME_ROOT)/make/Makefile.runtime.foot

=== debian/changelog ===
massivethreads (1.02-4) unstable; urgency=medium

  * Upload to unstable.
    + No update from exmerimental.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Sun, 26 Jan 2025 19:35:42 +0900

massivethreads (1.02-3) experimental; urgency=medium

  * d/rules: Disable LTO (Closes: #1015538)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Sun, 26 Jan 2025 17:59:15 +0900

massivethreads (1.02-1) experimental; urgency=medium

  * New upstream released. (Closes: #1014566)
  * d/patches:
    + Remove patches included in the release.
    + Refresh patches.
  * d/control:
    + Bump Standards-Version to 4.7.0.
  * Update d/copyright.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Sat, 25 Jan 2025 14:12:00 +0900

massivethreads (1.00-4) unstable; urgency=medium

  * Fix sparc64 support.
  * d/copyright
    - Get rid of lintian 'superfluous-file-pattern'
  * d/control
    - Bump Standards-Version to 4.6.0.1 (no change)
    - Change Architecture from any to specified arch

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Sun, 09 Jan 2022 13:38:14 +0900

massivethreads (1.00-3) unstable; urgency=medium

  * Update d/patches
   - Refresh patches.
   - Add supprort arm64 and sparc64.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 28 Sep 2021 16:48:21 +0900

massivethreads (1.00-2) unstable; urgency=medium

  * Update d/control:
    - Add Rules-Requires-Root: no
  * Add d/patches/0001-tests-Fix-build-on-x86_32.patch

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Fri, 24 Sep 2021 17:48:05 +0900

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,14 @@
 Priority: optional
 Section: devel
 Build-Depends: debhelper-compat (= 13)
-Standards-Version: 4.5.1
+Standards-Version: 4.7.0
+Rules-Requires-Root: no
 Homepage: https://github.com/massivethreads/massivethreads
 Vcs-Browser: https://salsa.debian.org/debian/massivethreads
 Vcs-Git: https://salsa.debian.org/debian/massivethreads.git
 
 Package: libmassivethreads0
-Architecture: any
+Architecture: amd64 arm64 i386 sparc64
 Section: libs
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -20,7 +21,7 @@
  This package includes the shared library.
 
 Package: libmassivethreads-dev
-Architecture: any
+Architecture: amd64 arm64 i386 sparc64
 Section: libdevel
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, libmassivethreads0 (= ${binary:Version})

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS=optimize=-lto
 
 %:
 	dh $@ --exclude=.la
